/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: perf_timer.h 783 2014-05-29 00:56:33Z honda $
 */

/*
 *  ޥɥ饤
 */
#ifndef PERF_TIMER_H
#define PERF_TIMER_H


/* ********************** ե꡼󥿥 ********************** */
/*
 *  ե꡼󥿥ޤΥ١ɥ쥹
 */
#ifndef TotalNumberOfCores
/* 󥰥륳ξ */
#else
/* ޥξ */
#endif  /* TotalNumberOfCores */

/*
 *  ޤΥ쥸
 */


/*
 *  ޴Ϣӥå
 */


/*
 *  ޥåñ̤[MHz]
 */

/*
 *	ޥͤ
 */

/*
 *  ޤθͤɽФ
 */
LOCAL_INLINE uint32
perf_timer_get_current(void)
{
    uint32 count;

	/*
	 * ե꡼󥿥ޥޤΥͤɤ߹
	 * 򤳤˼Ƽͤcount
	 * ܴؿͤꤹ
	 */

    return(count);
}

/*
 * 
 */
LOCAL_INLINE void
perf_get_100ntime(uint32 *p_time)
{
	/*
	 * *p_timeperf_timer_get_currentǼ
	 * 򥿥ޥåθƻѲͤꤹ
	 */
}


/* ********************** ޡʳѡ ********************** */
/*
 *  ޤΥ١ɥ쥹
 */
/* 󥰥륳ξ */
#ifndef TotalNumberOfCores
#define PERF_TIMER_BASE

/* ޥξ */
#else   /* TotalNumberOfCores */
#define PERF_TIMER_BASE
#endif  /* TotalNumberOfCores */

/*
 *  ޥ쥸
 */


/*
 *  ޴Ϣӥå
 */

/*
 * ޥåñ̤[MHz]
 */


/*
 * ޤμɽη
 */

#define INT_A_TIMER   0
#define INT_B_TIMER   1
#ifdef TotalNumberOfCores
#define INT_C_TIMER   2
#endif  /* TotalNumberOfCores */

/* ١ɥ쥹ơ֥ */
extern const uint32 int_timer_base_table[];

/*
 *  ޤθͤɽФ
 */
LOCAL_INLINE uint32
int_timer_get_current(uint32 tim_type)
{
	volatile uint32 int_timer_base;

	/* ޤΥ١ɥ쥹 */
	int_timer_base = int_timer_base_table[tim_type];

	/*
	 * int_timer_baseμޤΥͤɤ߹
	 * 򤳤˼Ƽͤcount
	 * ܴؿͤꤹ
	 */

    return(count);
}

/*
 * 
 */
LOCAL_INLINE void
int_get_100ntime(uint32 *p_time, uint32 tim_type)
{
	/* 
	 * *p_timeperf_timer_get_currentǼ
	 * 򥿥ޥåθƻѲͤꤹ
	 */
}

#endif /* PERF_TIMER_H */
