/*
 *  TOPPERS/A-OSBENCH
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Operating System Benchmark
 *
 *  Copyright (C) 2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014 by Sunny Giken Inc., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: perf_timer.c 783 2014-05-29 00:56:33Z honda $
 */

/*
 *  ޥɥ饤
 */

#include "perf_timer.h"


/* ********************** ե꡼󥿥 ********************** */

/*
 *  ޤεư
 */
void
perf_timer_initialize(void)
{
	/*
	 * ե꡼󥿥ޤư
	 * ޤưƤǽ뤿
	 * ޤΥȽ򤳤˼
	 */ 
}


/*
 *  ޤ߽
 */
void
perf_timer_terminate(void)
{
	/*
	 * ե꡼󥿥ޤߤܴؿˤ
	 * ޤΥȥå׽򤳤˼
	 */ 
}


/* ********************** ޡʳѡ ********************** */

/*
 *  ޤΥ١ɥ쥹ơ֥
 */
const uint32
int_timer_base_table[] = {
  INT_A_TIMER_BASE,
  INT_B_TIMER_BASE,
#ifdef TotalNumberOfCores
  INT_C_TIMER_BASE,
#endif  /* TotalNumberOfCores */
};


/*
 *  ޤεư
 */
void
int_timer_initialize(uint32 tim_type)
{
	volatile uint32 int_timer_base;
 
	/* ޤΥ١ɥ쥹 */
	int_timer_base = int_timer_base_table[tim_type];

	/*
	 * int_timer_baseμޤư
	 * ޤưƤǽ뤿
	 * ޤΥȽ򤳤˼
	 */ 
}


/*
 *  ޤ߽
 */
void
int_timer_terminate(uint32 tim_type)
{
	volatile uint32 int_timer_base;

	/* ޤΥ١ɥ쥹 */
	int_timer_base = int_timer_base_table[tim_type];

	/*
	 * int_timer_baseμޤߤܴؿˤ
	 * ޤΥȥå׽򤳤˼
	 */ 
}
}
